Bug 293534

Summary: flow control: possible to continue stopped flow without Konsole noticing
Product: konsole Reporter: Martin Steigerwald <martin.steigerwald>
Component: generalAssignee: Konsole Developer <konsole-devel>
Status: RESOLVED FIXED    
Severity: normal CC: adaptee, Martin
Priority: NOR    
Version: unspecified   
Target Milestone: ---   
Platform: Unlisted Binaries   
OS: Linux   
Latest Commit: Version Fixed In: 4.8.1
Attachments: the screenshot shows how its possible to break stopped flow without konsole noticing

Description Martin Steigerwald 2012-02-07 15:00:43 UTC
Created attachment 68590 [details]
the screenshot shows how its possible to break stopped flow without konsole noticing

Version:           unspecified
OS:                Linux

When I press Ctrl+s in Konsole while flow control is enabled in the profile settings I get a nice warning that output in shell has been halted and I may press Ctrl+q to continue. When I press Ctrl+q the warning disappears.

When I press Ctrl+c flow the shell also continues, but the warning stays. 

Reproducible: Always

Steps to Reproduce:
- make sure flow control is enabled in profile settings of Konsole (should be standard)
- open a Konsole window
- press Strg+s
- press Ctrl+c

In Z-Shell it suffices to press Ctrl+c once. In Bash I seem to have to press it twice.

Actual Results:  
I am able to write something into the shell again, while the warning is still there (see attached screenshot).

Expected Results:  
The warning disappears *or* Ctrl+c won't continue. I like Ctrl-c to continue tough for users of other terminal emulators without that nice warning message.

That Ctrl+c continues stopped flow could have been introduced by some recent software - at least I didn't see this behavior until a recent linux training where a student found it. I have:

ms@mango:~> apt-show-versions | egrep "(konsole/|readline|coreutils/|bash/|zsh/)"
bash/wheezy uptodate 4.2-1
coreutils/wheezy uptodate 8.13-3
konsole/experimental uptodate 4:4.7.4-1
libreadline5/wheezy uptodate 5.2-11
libreadline6/wheezy uptodate 6.2-8
readline-common/wheezy uptodate 6.2-8
zsh/wheezy uptodate 4.3.15-1
Comment 1 Kurt Hindenburg 2012-02-11 19:21:05 UTC
Git commit b9a69ec009d69d14561c07efc8559e4d6a708777 by Kurt Hindenburg.
Committed on 11/02/2012 at 20:19.
Pushed by hindenburg into branch 'master'.

Upon Ctrl+C cancel flow control

If flow control is enabled, it is cancelled upon Ctrl+C.  This mimics
xterm results.
FIXED-IN: 4.9

M  +7    -2    src/Vt102Emulation.cpp

http://commits.kde.org/konsole/b9a69ec009d69d14561c07efc8559e4d6a708777
Comment 2 Kurt Hindenburg 2012-02-11 19:51:01 UTC
Git commit e1ae91ce1f8664ae3105c8750fc9389ee2f2f9f8 by Kurt Hindenburg.
Committed on 11/02/2012 at 20:19.
Pushed by hindenburg into branch 'KDE/4.8'.

Upon Ctrl+C cancel flow control

If flow control is enabled, it is cancelled upon Ctrl+C.  This mimics
xterm results.
FIXED-IN: 4.9
(cherry picked from commit b9a69ec009d69d14561c07efc8559e4d6a708777)

M  +8    -4    src/Vt102Emulation.cpp

http://commits.kde.org/konsole/e1ae91ce1f8664ae3105c8750fc9389ee2f2f9f8
Comment 3 Martin Steigerwald 2012-02-11 20:51:52 UTC
Many thanks for such a quick fix for such IMHO quite minor issue, Kurt. Debian still has KDE SC 4.7.4, so it will take a while till I will get the fix, but I bet you tested it.